﻿/*----------------------------------------------------------------------------

  Desktop App Converter sample app

  Copyright(C) Web Technology Corp, all rights reserved.
  Code by Yoshiaki "Koumei" Hashimoto

----------------------------------------------------------------------------*/

#define STRICT
#include <stdlib.h>
#include <windows.h>

bool api_IsBridgedAppMode_1(bool& bBridgedMode);

// メインウィンドウプロシージャ
LRESULT CALLBACK MainWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:

		return 0;

	case WM_CLOSE:

		DestroyWindow(hWnd);
		return 0;

	case WM_DESTROY:
		
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// エントリーポイント
INT APIENTRY wWinMain(HINSTANCE hInst, HINSTANCE, LPWSTR, INT nShow)
{
	// ウィンドウクラス登録
	WNDCLASSEX wc = {};
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_OWNDC;
	wc.lpfnWndProc = MainWindowProc;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.hInstance = hInst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszClassName = L"dactestapp_mainwindow";
	if(!RegisterClassEx(&wc))
	{
		return 1;
	}

	// デスクトップブリッジモードで動作しているか？
	bool bBridgedMode;
	if(!api_IsBridgedAppMode_1(bBridgedMode))
	{
		return 2;
	}

	// ウィンドウ作成
	HWND hWnd = CreateWindow(wc.lpszClassName,
		bBridgedMode ? L"DAC Test App (ブリッジ モード)" : L"DAC Test App (デスクトップ モード)",
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInst, NULL);
	if(!hWnd)
	{
		return 3;
	}

	// ウィンドウ表示
	ShowWindow(hWnd, nShow);
	UpdateWindow(hWnd);

	// コマンドライン引数があれば表示
	if(__argc > 1)
	{
		MessageBox(hWnd, __wargv[1], L"__wargv[1]", MB_OK);
	}

	// メッセージループ
	MSG msg;
	while(GetMessage(&msg, NULL, 0L, 0L) > 0)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}
